import java.util.Random;
import java.util.concurrent.Callable;

public class ExecutorTask implements Callable<Integer> {
	private String id; 
	
	ExecutorTask(int id) {
		super();
		this.id = "Task "+id;
	}

	public Integer call() throws Exception {
		int delay = new Random().nextInt(500);
		try {
			Thread.sleep(delay);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println(id+" executed." );
		return delay;
	}
	
}
