import java.util.Iterator;
import java.util.Random;
import java.util.concurrent.ConcurrentHashMap;

public class HashMapEmpty implements Runnable {
	ConcurrentHashMap<String,String> cMap = new ConcurrentHashMap<String,String>();

	HashMapEmpty (ConcurrentHashMap<String,String> cMap) {
		super();
		this.cMap = cMap;
	}
	
	public void run ( ) {
		Iterator<String> i = cMap.keySet().iterator();
		while (i.hasNext()) {
			String s = i.next();
			if (cMap.replace(s, "in stock", "sold out")) {
				System.out.println(s+" sold out");
			}
			try {
				Thread.sleep(new Random().nextInt(500));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}	

}
