import java.util.concurrent.locks.ReentrantReadWriteLock;

public class RWLockExample {
	private int value = 0;
	private ReentrantReadWriteLock lock 
			= new ReentrantReadWriteLock();
		
	public int read ( ) {
		try {
			lock.readLock().lock();
			System.out.println("Read Lock: " 
					+ lock.getReadLockCount());
			return value;
		} finally {
			System.out.println("Read lock released.");
			lock.readLock().unlock();
		}
	}

	public int writeNewValue (int newValue) {
		try {
			lock.writeLock().lock();
			System.out.println("Write Lock: " 
					+ lock.getWriteHoldCount());
			value = newValue;
			return value;
		} finally {
			System.out.println("Write lock released.");
			lock.writeLock().unlock();
		}
	}	
}
